import pygame
import math


def get_angle(p1, p2):
    dx = p2[0] - p1[0]
    dy = p2[1] - p1[1]
    rads = math.atan2(-dy,dx)
    rads %= 2*math.pi
    degs = math.degrees(rads)
    return degs


class Fahrzeug(pygame.sprite.Sprite):
    def __init__(self, x, y):
        super().__init__()
        self.image = pygame.image.load("player.png").convert_alpha()
        self.rect = self.image.get_rect(center=(x, y))
        self.rect.centerx = x
        self.rect.centery = y
        self.speed = 1
        self.dest_x = x
        self.dest_y = y
        self.direction = pygame.math.Vector2(0, -1)
        self.angle = 0
        self.Tank = 100

    def draw(self, win):
        rotated_image = pygame.transform.rotate(self.image, self.angle)
        rotated_rect = rotated_image.get_rect(center=self.rect.center)

        #debug, nicht anrühren
        #self.angle += 1
        #pygame.draw.rect(win, (255, 0, 0), rotated_rect)

        win.blit(rotated_image, rotated_rect)

    def update(self):
        if self.Tank > 0:
            if self.rect.centerx < self.dest_x:
                self.rect.centerx += self.speed
            if self.rect.centerx > self.dest_x:
                self.rect.centerx -= self.speed
            if self.rect.centery < self.dest_y:
                self.rect.centery += self.speed
            if self.rect.centery > self.dest_y:
                self.rect.centery -= self.speed

        if  self.rect.centerx != self.dest_x or self.rect.centery != self.dest_y:
            if self.Tank > 0:
                self.Tank -= 0.1
            self.angle = get_angle((self.rect.centerx, self.rect.centery), (self.dest_x, self.dest_y))-90

    def dest(self, pos):
        self.dest_x, self.dest_y = pos
